//+------------------------------------------------------------------+
//|                                             Fibonacci_Weekly.mq4 |
//|                         Copyright  2009, kris.pivo[at]gmail.com |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 SeaGreen
#property indicator_color2 Green
#property indicator_color3 Silver
#property indicator_color4 Gray
#property indicator_color5 Gray
#property indicator_color6 Silver
#property indicator_color7 Red
#property indicator_color8 Crimson
//---- input parameters
int fontsize=8;
//---- buffers
double P1618Buffer[];
double P1272Buffer[];
double WHBuffer[];
double F0618Buffer[];
double F0382Buffer[];
double WLBuffer[];
double N1272Buffer[];
double N1618Buffer[];


string WHi="WeeklyHigh", WLo="Weekly Low";

string F382="Fib 0.382", NF1272="Fib -1.272", NF1618="Fib -1.618";
string F618="Fib 0.618", PF1272="Fib +1.272", PF1618="Fib +1.618";

double WH,WL,PP,S1,R1,S2,R2,S3,R3;
double Fib0618,FibP1272,FibP1618;
double Fib0382,FibN1272,FibN1618;
double last_week_high, last_week_low, this_week_open, last_week_close;
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   ObjectDelete("PF1618");
   ObjectDelete("PF1272");
   ObjectDelete("WHi");
   ObjectDelete("F618");
   ObjectDelete("F382");
   ObjectDelete("WLo");
   ObjectDelete("NF1272");
   ObjectDelete("NF1618");
   
	ObjectDelete("FiP161");
	ObjectDelete("FiP127");
	ObjectDelete("Fib100");
	ObjectDelete("Fib618");
	ObjectDelete("Fib382");
	ObjectDelete("Fib000");
	ObjectDelete("FiN127");
	ObjectDelete("FiN162");
	
	Comment("");
	return(0); }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,160);
   SetIndexBuffer(0,P1618Buffer);
   SetIndexLabel(0,"Fib +1.618");

   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,160);
   SetIndexBuffer(1,P1272Buffer);
   SetIndexLabel(1,"Fib +1.272");

   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,167);
   SetIndexBuffer(2,WHBuffer);
   SetIndexLabel(2,"Weekly High");
   
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,160);
   SetIndexBuffer(3,F0618Buffer);
   SetIndexLabel(3,"Fib 0.618");

   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,160);
   SetIndexBuffer(4,F0382Buffer);
   SetIndexLabel(4,"Fib 0.382");

   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,167);
   SetIndexBuffer(5,WLBuffer);
   SetIndexLabel(5,"Weekly Low");

   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,160);
   SetIndexBuffer(6,N1272Buffer);
   SetIndexLabel(6,"Fib -1.272");

   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,160);
   SetIndexBuffer(7,N1618Buffer);
   SetIndexLabel(7,"Fib -1.618");

//---- name for DataWindow and indicator subwindow label
   short_name="Fibonacci Weekly";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,1);
//----
   return(0);
  }

int start()
  {
   int counted_bars=IndicatorCounted();
   int limit, i;
//---- indicator calculation
   if (counted_bars==0)
     {
      ObjectCreate("PF1618", OBJ_TEXT, 0,0,0);
      ObjectSetText("PF1618", "                                            Fib +1.618",fontsize,"Arial",indicator_color1);
      ObjectCreate("PF1272", OBJ_TEXT, 0,0,0);
      ObjectSetText("PF1272", "                                            Fib +1.272",fontsize,"Arial",indicator_color2);
      ObjectCreate("WHi", OBJ_TEXT, 0,0,0);
      ObjectSetText("WHi", "                                               Weekly High",fontsize,"Arial",indicator_color3);
      ObjectCreate("F618", OBJ_TEXT, 0,0,0);
      ObjectSetText("F618", "                                              Fib  0.618",fontsize,"Arial",indicator_color4);
      ObjectCreate("F382", OBJ_TEXT, 0,0,0);
      ObjectSetText("F382", "                                              Fib  0.382",fontsize,"Arial",indicator_color5);
      ObjectCreate("WLo", OBJ_TEXT, 0,0,0);
      ObjectSetText("WLo", "                                               Weekly Low",fontsize,"Arial",indicator_color6);
      ObjectCreate("NF1272", OBJ_TEXT, 0,0,0);
      ObjectSetText("NF1272", "                                            Fib -1.272",fontsize,"Arial",indicator_color7);
      ObjectCreate("NF1618", OBJ_TEXT, 0,0,0);
      ObjectSetText("NF1618", "                                            Fib -1.618",fontsize,"Arial",indicator_color8);
     }
   if(counted_bars<0) return(-1);
//----
   limit=(Bars-counted_bars)-1;
//----
   for(i=limit; i>=0;i--)
     {
      // Monday
      if(1==TimeDayOfWeek(Time[i]) && 1!=TimeDayOfWeek(Time[i+1]) )
        {
         last_week_close=Close[i+1];
         this_week_open=Open[i];
         // Weekly High
         WH=last_week_high;
         WL=last_week_low;
         double R = (WH - WL);
         FibP1618 = WH + R * 0.618;
         FibP1272 = WH + R * 0.272;
         Fib0618  = WL + R * 0.618;
         Fib0382  = WL + R * 0.382;
         FibN1272 = WL - R * 0.272;
         FibN1618 = WL - R * 0.618;	   
         last_week_low  = Low[i];
         last_week_high = High[i];
//----
         ObjectMove("PF1618", 0, Time[i],FibP1618);
         ObjectMove("PF1272", 0, Time[i],FibP1272);
         ObjectMove("WHi", 0, Time[i],WH);
         ObjectMove("F618", 0, Time[i],Fib0618);
         ObjectMove("F382", 0, Time[i],Fib0382);
         ObjectMove("WLo", 0, Time[i],WL);
         ObjectMove("NF1272", 0, Time[i],FibN1272);
         ObjectMove("NF1618", 0, Time[i],FibN1618);
        }
      last_week_high=MathMax(last_week_high, High[i]);
      last_week_low=MathMin(last_week_low, Low[i]);
      
      P1618Buffer[i]=FibP1618;
      P1272Buffer[i]=FibP1272;
      WHBuffer[i]=WH;
      F0618Buffer[i]=Fib0618;
      F0382Buffer[i]=Fib0382;
      WLBuffer[i]=WL;
      N1272Buffer[i]=FibN1272;
      N1618Buffer[i]=FibN1618;

   DoLabel( "FiP161", P1618Buffer[0], indicator_color1 );
   DoLabel( "FiP127", P1272Buffer[0], indicator_color2 );
   DoLabel( "Fib100", WHBuffer[0],    indicator_color3 );
   DoLabel( "Fib618", F0618Buffer[0], indicator_color4 );
   DoLabel( "Fib382", F0382Buffer[0], indicator_color5 );
   DoLabel( "Fib000", WLBuffer[0],    indicator_color6 );
   DoLabel( "FiN162", N1272Buffer[0], indicator_color7 );
   DoLabel( "FiN162", N1618Buffer[0], indicator_color8 );
	}
	return(0); }
	
void DoLabel( string dName, double dValue, color dColor )
   {
   if (ObjectFind(dName) != 0)
      {
      ObjectCreate(dName,OBJ_ARROW,0,Time[0],dValue);
      ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
      ObjectSet(dName,OBJPROP_COLOR,dColor);  
      } 
   else
      {
      ObjectMove(dName,0,Time[0],dValue);
      }
   }      
//     }
////----
//   return(0);
//  }
//+------------------------------------------------------------------+