//+------------------------------------------------------------------+
//| #BobokusFibo.mq4 modified from
//| #SpudFibo.mq4
//| http://www.forexfactory.com/showthread.php?t=50767
//+------------------------------------------------------------------+
#property  indicator_chart_window

#property indicator_buffers 3
#property indicator_color1 Navy 
#property indicator_color2 White 
#property indicator_color3 DodgerBlue 


double HiPrice, LoPrice, Range;
datetime StartTime;

int init()
{
   return(0);
}

int deinit()
{
   ObjectDelete("LongFibo9");
   ObjectDelete("ShortFibo9");
   ObjectDelete("dailyFibo9");
   return(0);
}

//+------------------------------------------------------------------+
//| Draw Fibo
//+------------------------------------------------------------------+

int DrawFibo()
{
	if(ObjectFind("LongFibo9") == -1)
		ObjectCreate("LongFibo9",OBJ_FIBO,0,StartTime,HiPrice+Range,StartTime,HiPrice);
	else
	{
		ObjectSet("LongFibo9",OBJPROP_TIME2, StartTime);
		ObjectSet("LongFibo9",OBJPROP_TIME1, StartTime);
		ObjectSet("LongFibo9",OBJPROP_PRICE1,HiPrice+Range);
		ObjectSet("LongFibo9",OBJPROP_PRICE2,HiPrice);
	}
   ObjectSet("LongFibo9",OBJPROP_LEVELCOLOR,indicator_color1);
   ObjectSet("LongFibo9",OBJPROP_FIBOLEVELS,4);
   ObjectSet("LongFibo9",OBJPROP_FIRSTLEVEL+0,0.382);	ObjectSetFiboDescription("LongFibo9",0,"Daily Long Target 1 -  %$"); 
   ObjectSet("LongFibo9",OBJPROP_FIRSTLEVEL+1,0.618);	ObjectSetFiboDescription("LongFibo9",1,"Daily Long Target 2 -  %$"); 
   ObjectSet("LongFibo9",OBJPROP_FIRSTLEVEL+2,1.618);	ObjectSetFiboDescription("LongFibo9",2,"Daily Long Target 4 -  %$"); 
   ObjectSet("LongFibo9",OBJPROP_FIRSTLEVEL+3,1.236);	ObjectSetFiboDescription("LongFibo9",3,"Daily Long Target 3 -  %$"); 
   ObjectSet("LongFibo9",OBJPROP_RAY,true);
   ObjectSet("LongFibo9",OBJPROP_BACK,true);

	if(ObjectFind("ShortFibo9") == -1)
		ObjectCreate("ShortFibo9",OBJ_FIBO,0,StartTime,LoPrice-Range,StartTime,LoPrice);
	else
	{
		ObjectSet("ShortFibo9",OBJPROP_TIME2, StartTime);
		ObjectSet("ShortFibo9",OBJPROP_TIME1, StartTime);
		ObjectSet("ShortFibo9",OBJPROP_PRICE1,LoPrice-Range);
		ObjectSet("ShortFibo9",OBJPROP_PRICE2,LoPrice);
	}
   ObjectSet("ShortFibo9",OBJPROP_LEVELCOLOR,indicator_color3); 
   ObjectSet("ShortFibo9",OBJPROP_FIBOLEVELS,4);
   ObjectSet("ShortFibo9",OBJPROP_FIRSTLEVEL+0,0.382);	ObjectSetFiboDescription("ShortFibo9",0,"Daily Short Target 1 -  %$"); 
   ObjectSet("ShortFibo9",OBJPROP_FIRSTLEVEL+1,0.618);	ObjectSetFiboDescription("ShortFibo9",1,"Daily Short Target 2 -  %$"); 
   ObjectSet("ShortFibo9",OBJPROP_FIRSTLEVEL+2,1.618);	ObjectSetFiboDescription("ShortFibo9",2,"Daily Short Target 4 -  %$"); 
   ObjectSet("ShortFibo9",OBJPROP_FIRSTLEVEL+3,1.236);	ObjectSetFiboDescription("ShortFibo9",3,"Daily Short Target 3 -  %$");
   ObjectSet("ShortFibo9",OBJPROP_RAY,true);
   ObjectSet("ShortFibo9",OBJPROP_BACK,true);

		if(ObjectFind("dailyFibo9") == -1)
			ObjectCreate("dailyFibo9",OBJ_FIBO,0,StartTime,HiPrice,StartTime+PERIOD_D1*60,LoPrice);
		else
		{
			ObjectSet("dailyFibo9",OBJPROP_TIME2, StartTime);
			ObjectSet("dailyFibo9",OBJPROP_TIME1, StartTime+PERIOD_D1*60);
			ObjectSet("dailyFibo9",OBJPROP_PRICE1,HiPrice);
			ObjectSet("dailyFibo9",OBJPROP_PRICE2,LoPrice);
		}
   	ObjectSet("dailyFibo9",OBJPROP_LEVELCOLOR,indicator_color2); 
   	ObjectSet("dailyFibo9",OBJPROP_FIBOLEVELS,7);
   	ObjectSet("dailyFibo9",OBJPROP_FIRSTLEVEL+0,0.382);	ObjectSetFiboDescription("dailyFibo9",0,"daily Short -  %$"); 
   	ObjectSet("dailyFibo9",OBJPROP_FIRSTLEVEL+1,0.382);	ObjectSetFiboDescription("dailyFibo9",1,"daily Short -  %$"); 
   	ObjectSet("dailyFibo9",OBJPROP_FIRSTLEVEL+2,0.382);	ObjectSetFiboDescription("dailyFibo9",2,"daily Short -  %$"); 
   	ObjectSet("dailyFibo9",OBJPROP_FIRSTLEVEL+3,0.500);	ObjectSetFiboDescription("dailyFibo9",3,"daily Pivot -  %$"); 
   	ObjectSet("dailyFibo9",OBJPROP_FIRSTLEVEL+4,0.618);	ObjectSetFiboDescription("dailyFibo9",4,"daily Long -  %$"); 
   	ObjectSet("dailyFibo9",OBJPROP_FIRSTLEVEL+5,0.618);	ObjectSetFiboDescription("dailyFibo9",5,"daily Long -  %$"); 
   	ObjectSet("dailyFibo9",OBJPROP_FIRSTLEVEL+6,0.618);	ObjectSetFiboDescription("dailyFibo9",6,"daily Long -  %$"); 
   	ObjectSet("dailyFibo9",OBJPROP_RAY,true);
   	ObjectSet("dailyFibo9",OBJPROP_BACK,true);
   }

//+------------------------------------------------------------------+
//| Indicator start function
//+------------------------------------------------------------------+

int start()
{
	int shift	= iBarShift(NULL,PERIOD_D1,Time[0]) + 1;	// yesterday
	HiPrice		= iHigh(NULL,PERIOD_D1,shift);
	LoPrice		= iLow (NULL,PERIOD_D1,shift);
	StartTime	= iTime(NULL,PERIOD_D1,shift);

	if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
	{//Add fridays high and low
		HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_D1,shift+1));
		LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_D1,shift+1));
	}

	Range = HiPrice-LoPrice;

	DrawFibo();

	return(0);
}
//+------------------------------------------------------------------+

